<template>
    <el-dialog draggable class="cn-operate-dialog" width="500px" v-model="dialogVisible" :title="title">
        <el-scrollbar>
            <el-form :inline="false" :model="form" label-width="120px" :rules="rules" ref="formRef">
                <el-form-item label="角色名称" prop="name">
                    <el-input v-model="form.name" placeholder="请输入角色名称"  maxlength="32" show-word-limit @input="handleInput"/>
                </el-form-item>
                <el-form-item label="角色编码" prop="code">
                    <el-input v-model="form.code" placeholder="请输入角色编码" maxlength="32" show-word-limit/>
                </el-form-item>
                <el-form-item label="角色描述">
                    <el-input v-model="form.remark" :rows="2" type="textarea" placeholder="请输入描述" maxlength="100" show-word-limit/>
                </el-form-item>
            </el-form>
        </el-scrollbar>

        <template #footer>
            <span class="dialog-footer">
                <el-button @click="dialogVisible = false">取消</el-button>
                <el-button type="primary" @click="submit">确认</el-button>
            </span>
        </template>
    </el-dialog>
</template>
<script lang="ts" setup>
import { ref, inject } from 'vue'
import { reactive } from 'vue'
import TableStore from '@/utils/tableStore'
import { ElMessage } from 'element-plus'
import { add, update } from '@/api/user-boot/role'
import { useAdminInfo } from '@/stores/adminInfo'

const adminInfo = useAdminInfo()
const tableStore = inject('tableStore') as TableStore
const formRef = ref()
// do not use same name with ref
const form = reactive({
    code: '',
    name: '',
    remark: '',
    id: '',
    type: 0
})
const rules = {
    name: [{ required: true, message: '角色名称不能为空', trigger: 'blur' }],
    code: [{ required: true, message: '角色编码不能为空', trigger: 'blur' }]
}
const dialogVisible = ref(false)
const title = ref('新增菜单')
const open = (text: string, data?: anyObj) => {
    title.value = text
    dialogVisible.value = true
    if (data) {
        for (let key in form) {
            form[key] = data[key]
        }
    } else {
        for (let key in form) {
            form[key] = ''
        }
    }
}
const submit = async () => {
    formRef.value.validate(async (valid: boolean) => {
        if (valid) {
          if (form.id) {
            await update(form)
        } else {
            form.type = adminInfo.$state.userType + 1
            await add(form)
        }
        ElMessage.success('保存成功')
        tableStore.index()
        dialogVisible.value = false
        }
    })
}

const handleInput = (val: string) => {
    form.name = val.replace(/\s+/g, '')
}

defineExpose({ open })
</script>
